<?php
/*
  Injader - Content management for everyone
  Copyright (c) 2005-2009 Ben Barden
  Please go to http://www.injader.com if you have questions or need help.

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

  require '../sys/header.php';
  $CMS->RES->Admin();
  if ($CMS->RES->IsError()) {
    $CMS->Err_MFail(M_ERR_UNAUTHORISED, "Admin");
  }
  
  $strAction = empty($_GET['action']) ? "" : $CMS->FilterAlphanumeric($_GET['action'], "");
  if (!$strAction) {
    $CMS->Err_MFail(M_ERR_MISSINGPARAMS_SYSTEM, "action");
  }
  
  $intID = empty($_GET['id']) ? "" : $CMS->FilterNumeric($_GET['id']);
  if (!$intID) {
    $CMS->Err_MFail(M_ERR_MISSINGPARAMS_SYSTEM, "ID");
  }
  
  $strSysVersion  = $CMS->SYS->GetSysPref(C_PREF_CMS_VERSION);
  $strCompanyURL  = PRD_PRODUCT_URL;
  $strCompanyName = PRD_COMPANY_NAME;
  $strExportFile  = "";
  $intDateYear    = date('Y');
  
  $strFileHeader = <<<FileHeader
----------------------------------------
? Injader Export File - Generated by Injader $strSysVersion
? Copyright (c) $intDateYear $strCompanyName
----------------------------------------
? Do not edit this file directly!
? Need help? Go to $strCompanyURL and click on Help Forum.
----------------------------------------
FileHeader;
  
  switch ($strAction) {
    case "exportplugin":
      $arrPlugin = $CMS->PLG->Get($intID);
      if (!$arrPlugin) {
        $CMS->Err_MFail(M_ERR_NO_ROWS_RETURNED, "Plugin: $intID");
      }
      $strName      = $arrPlugin['name'];
      $strVersion   = $arrPlugin['version'];
      $strSQL       = $arrPlugin['query_string'];
      $intItemLimit = $arrPlugin['item_limit'];
      $strVariable  = $arrPlugin['plugin_variable'];
      $strTemplate  = $arrPlugin['plugin_template'];
      // ** START EXPORT FILE ** //
      $strExportFile = <<<ExportHeader
$strFileHeader
!Action:CMS_CreatePlugin
!Name:$strName
!Version:$strVersion
!QueryString:$strSQL
!ItemLimit:$intItemLimit
!Variable:$strVariable
!PluginTemplateStart:
----------------------------------------
$strTemplate
----------------------------------------
!PluginTemplateEnd:
!End!
----------------------------------------

ExportHeader;
      break;
  }
  
  if ($strExportFile) {
    // ** OUTPUT EXPORT FILE ** //
    header("Pragma: public"); // required
    header("Expires: 0");
    header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
    header("Cache-Control: private", false); // required for certain browsers
    header('Content-type: text/plain');
    header("Content-Transfer-Encoding: binary");
    header("Content-Disposition: attachment; filename=\"exportdata.txt\"");
    exit($strExportFile);
  }

?>